<?php

class SpecialCryptoPhotoAuth extends SpecialPage {
  var $success = false;

  function __construct() {
    parent::__construct( 'CryptoPhotoAuth', '', false );
  }

  function execute( $par ) {
    global $wgUser, $mediaWiki, $wgRequest, $wgOut, $wgCryptoPhotoConfig, $IP, $wgServer, $wgScriptPath, $wgSecretKey;

    $this->setHeaders();

    //check for authenticated user
    if ($wgUser->isLoggedIn()) {
     
      //check for valid keys and enabled cryptophoto
      if ($wgUser->getOption( 'cryptophoto_enabled' ) && isset($wgCryptoPhotoConfig['privatekey']) && isset($wgCryptoPhotoConfig['publickey'])) {
        $userid = $wgUser->getId();
        $cp = new CryptoPhotoUtils($wgCryptoPhotoConfig['privatekey'], 
                                   $wgCryptoPhotoConfig['publickey'], 
                                   md5($wgCryptoPhotoConfig['salt'] . $userid));
        $cp->start_session();
          
        //check whether the user has previously downloaded a token or not
        if($cp->has_token != 'true') {
          //if the user doesn't have a token, he will logged in as ususal
          self::redirect();
        } else {
            //for users with a downloaded token, CP authentication is required
            $wgOut->addHtml("<form method='POST'>".$cp->get_auth_widget()."<input type='submit' name='cp_auth' value='Authenticate'></form>");
            $wgUser->logout();
            $_SESSION['cpid'] = $userid;
          }
        }
        else {
          self::redirect();
          return;
        }
      
    } 
      //guest detected
      else if ($_SESSION['cpid']) {

      //new cryptophoto instance
      $cp = new CryptoPhotoUtils($wgCryptoPhotoConfig['privatekey'], 
                           $wgCryptoPhotoConfig['publickey'], 
                           md5($wgCryptoPhotoConfig['salt'] . $_SESSION['cpid']));
      
      //user posted something
      if((isset($_POST["cp_auth"]) && !empty($_POST["cp_auth"])) || isset($_POST["cp_phc"])) {
        //test for non-empty or blank post
      	if((!empty($_POST["token_response_field_row"]) && !empty($_POST["token_response_field_col"])) || (!empty($_POST["cp_phc"]))) {
          // check the post
          if ($_POST["token_selector"] && ( ($_POST["token_response_field_row"] && $_POST["token_response_field_col"]) || $_POST["cp_phc"]) ) {
            
            $selector = $_POST["token_selector"];
            $row_code = $_POST["token_response_field_row"] ? $_POST["token_response_field_row"] : "";
            $col_code = $_POST["token_response_field_col"] ? $_POST["token_response_field_col"] : "";
            $cp_phc   = $_POST["cp_phc"] ? $_POST["cp_phc"] : "";
            $ip       = $_SERVER['REMOTE_ADDR'];
      
            $cp->verify_response($selector, $row_code, $col_code, $cp_phc, $ip);
            
            // codes ok, let's finally login the user
            if($cp->is_valid) {
              $wgUser->setId($_SESSION['cpid']);
              $_SESSION['cpid'] = NULL;
              unset($_SESSION['cpid']);
              
              $wgUser->loadFromId();
              $wgUser->setCookies();
              $wgOut->addHtml("<script type='text/javascript'> history.go(1); window.onload=function(){ setTimeout(function(){window.location = 'index.php?title=Main_Page'}, 1000); } </script>" . "<p>You've been successfuly authenticated. Redirecting now to Main page.</p>");
    
            } else {
                $cperror = $cp->error;
                $cp->start_session();

                if($cperror == "incorrect-retry-count") {
                  $error_message = "";
                }
                if($cperror == "incorrect-verify-call") {
                  $error_message = "Codes don't match";
                }

                $wgOut->addHtml("<form method='POST'><p style='color:#f00'>". $error_message . "</p>" .$cp->get_auth_widget()."<input type='submit' name='cp_auth' value='Authenticate'></form>"); 
              }
          }
	      }
        //empty input codes
        else {
          $cp->start_session();
          $wgOut->addHtml("<form method='POST'><p style='color:#f00'>You must fill in both codes</p>".$cp->get_auth_widget()."<input type='submit' name='cp_auth' value='Authenticate'></form>");
        }
      } 
      
      //empty post
      else {
        $cp->start_session();
        $wgOut->addHtml("<form method='POST'>".$cp->get_auth_widget()."<input type='submit' name='cp_auth' value='Authenticate'></form>");
      }
    } 
    
    //attempt to reach the PC authentication page, without valid login
    else {
      $wgOut->addWikiText("You must login to see this page.");
    }
  }
    
  //redirect method
  function redirect ($page = "") {
    global $wgUser, $mediaWiki, $wgRequest, $wgOut;
    if($page) {
      $wgOut->redirect($page);
      return;
    }
    $returnto = $wgRequest->getVal("returnto");
    if ($returnto) {
      $wgOut->redirect($returnto); //action=purge is used to purge the cache
    } else {
      $wgOut->redirect("index.php?title=Main_Page");
    }
  }
}
?>
